#!/bin/sh
# here is a sample html viewer to demonstrate the library usage
# Copyright (c) 1995 by Sun Microsystems
#
# See the file "license.terms" for information on usage and redistribution
# of this file, and for a DISCLAIMER OF ALL WARRANTIES.
#
# This REQUIRES Tk4.0 -- make sure "wish" on the next line is a 4.0 version
# The next line is a TK comment, but a shell command \
#  exec wish4.2 -f "$0" "$@" & exit 0

#if {$tk_version < 4.0 || [regexp {b[123]} $tk_patchLevel] } {
#	puts stderr "This library requires TK4.0, this is only $tk_version, \
#			patchlevel $tk_patchLevel"
#	exit 1
#}
#if {[catch {array get env *}]} {
#	puts stderr "This library requires tcl7.4, this version is too old!"
#	exit 1
#}
puts stderr "Starting sample HTML viewer..."

source $rootdirectory/drug_programs/html_library.tcl

# construct a simple user interface

proc setup {} {
   global rootdirectory
   global tcl_platform
   global name
	frame .frame
	menubutton .menu -relief raised -bd 2 -text options... -menu .menu.m
	button .quit  -bg red -fg yellow -command exit  -text quit
        button .findb -command find -text "Search"
        button .edit  -command {toplevel .t5 ;text .t5.text  -width 80 -height 25 -wrap word -yscrollcommand ".t5.scroll set"
        ;pack .t5.text -side left -fill both -expand true
        ;scrollbar .t5.scroll -command ".t5.text yview"
        ;wm title .t5 $name
        ;pack .t5.scroll -side left -fill y;loadFileEdit $rootdirectory/progress_notes/${name}.htm .t5.text
        ;button .t5.save -command {writeFileEdit $rootdirectory/progress_notes/${name}.htm .t5.text} -text Save
        ;pack .t5.save -side bottom -fill x
        ; button .t5.delete -bg red -fg yellow -text "Del. File" -command {
         toplevel .allergysure
         ;label .allergysure.question -text "Sure? Really delete $rootdirectory/progress_notes/${name}.htm"
         ;button .allergysure.yes  -command "file delete $rootdirectory/progress_notes/${name}.htm;destroy .allergysure;destroy .t;bell" -text Yes;
         ;button .allergysure.no -command "destroy .allergysure" -text No;pack .allergysure.question .allergysure.yes .allergysure.no}
        ;pack .t5.delete -side bottom -anchor sw -fill x
        ;button .t5.exit -fg red -bg yellow -text Exit -command {destroy .t5}
        ;pack .t5.exit -side top -fill x
        ;button .t5.center -text <CENTER> -command {set bingo [.t5.text tag ranges sel];.t5.text insert [lindex $bingo 1] "</CENTER>";.t5.text insert [lindex $bingo 0] "<CENTER>"} 
        ;pack .t5.center -side top -fill x
        ;button .t5.paragraph -text <P> -command {.t5.text insert insert <P>}
        ;pack .t5.paragraph -side top -fill x
        ;button .t5.break -text <BR> -command {.t5.text insert insert <BR>}
        ;pack .t5.break -side top -fill x
        ;button .t5.ul -text <UL> -command {.t5.text insert insert <UL>}
        ;pack .t5.ul -side top -fill x
        ;button .t5.li -text <LI> -command {.t5.text insert insert <LI>}
        ;pack .t5.li -side top -fill x
        ;button .t5.anchor -text <A> -command {set bang [.t5.text tag ranges sel];.t5.text insert [lindex $bang 1] "</A>";.t5.text insert [lindex $bang 0] "<A href=\"\">"}
        ;pack .t5.anchor -side top -fill x
        ;button .t5.pre -text <PRE> -command {set nono [.t5.text tag ranges sel];.t5.text insert [lindex $nono 1] "</PRE>";.t5.text insert [lindex $nono 0] "<PRE>"}
        ;pack .t5.pre -side top -fill x
         } -text Edit

              balloonhelp .edit "Loads the presently displayed \n HTML file in a text widget window \n your can edit the HTML code and
        resave it to make changes"
        
        button .print -text Print -bg darkslateblue -fg yellow -command {
        if {$tcl_platform(os) == "Linux"} {
           exec netscape [string trimleft $Url file:] &       
           } else {
            exec c:/progra~1/Netscape/Communicator/Program/netscape.exe $Url &
           }
        }

        balloonhelp .print "Loads the current HTML file \n into Netscape for printing or \n WYSIWYG editing. At least \n until I can print HTML \n directly from Tcl/Tk!"



	entry .entry  -textvariable Url -width 35
	label .file  -text file:
	label .status -textvariable Running -width 6 -relief ridge \
			-bd 2 -padx 9 -pady 3
	label .msg -textvariable message
	scrollbar .scrollbar  -command ".text yview"  -orient v
	option add *Text.height 20 startup
	option add *Text.width 48 startup
        if {$rootdirectory == "/root"} {
        text .text  -width 69 -height 25 -wrap word -yscrollcommand ".scrollbar set"  -takefocus 0 -bg ivory -tabs 5c
         } else {
        text .text  -width 69 -height 20 -wrap word -yscrollcommand ".scrollbar set"  -takefocus 0 -bg ivory -tabs 5c
         }
        pack .frame .msg -in .cpd18.01  -side top
	pack  .scrollbar -in .cpd18.01  -side left -expand 0 -fill y
#        pack .text -in .cpd18.01 -side left -fill both -expand 1
	
        pack .edit .print .file .entry .status .menu .quit .findb -in .frame -side left
        place .text -in .cpd18.01 -x 22 -y 45 -bordermode ignore

	# set up some sample keyboard ]bindings for the text widget
#        if {$rootdirectory == "/root"} {
#        bind .entry <Return> {catch {exec URLget.tcl $Url tempurlfile.html &};set Url "";after 25000 "render ./tempurlfile.html"}
#        } else {
      #  bind .entry <Return> {catch {exec URLget.bat $Url tempurlfile.html &};set Url "";after 25000 "render ./tempurlfile.html"}
         bind .entry <Return> {catch {CreateBrowserButtons;HB_init .text;HB_load_url .text $Url}}
#        }
#       bind .entry <Return> {render $Url}
	bind all <End> {.text yview end}
	bind all <Home> {.text yview 0.0}
	bind all <Next> {.text yview scroll 1 page}
	bind all <Prior> {.text yview scroll -1 page}

	# I'm constantly being criticized for never using menus.
	# so here's a menu.  So there.
	menu .menu.m
	.menu.m add command -label "option menu"
	.menu.m add separator
	.menu.m add command -label "font size" -foreground red 
	.menu.m add radiobutton -label small -value 0   -variable Size \
		-command {HMset_state .text -size $Size; render $Url}
	.menu.m add radiobutton -label medium -value 4  -variable Size \
		-command {HMset_state .text -size $Size; render $Url}
	.menu.m add radiobutton -label large -value 12  -variable Size \
		-command {HMset_state .text -size $Size; render $Url}
	.menu.m add separator
	.menu.m add command -label "indent level" -foreground red
	.menu.m add radiobutton -label small -value 0.6 -variable Indent \
		-command {HMset_indent .text $Indent}
	.menu.m add radiobutton -label medium -value 1.2 -variable Indent \
		-command {HMset_indent .text $Indent}
	.menu.m add radiobutton -label large -value 2.4 -variable Indent \
		-command {HMset_indent .text $Indent}
}

# Go render a page.  We have to make sure we don't render one page while
# still rendering the previous one.  If we get here from a recursive 
# invocation of the event loop, cancel whatever we were rendering when
# we were called.
# If we have a fragment name, try to go there.

proc render {file} {
	global HM.text Url
	global Running message

	set fragment ""
	regexp {([^#]*)#(.+)} $file dummy file fragment
	if {$file == "" && $fragment != ""} {
		HMgoto .text $fragment
		return
	}
	HMreset_win .text
	set Running busy
	set message "Displaying $file"
	update idletasks
	if {$fragment != ""} {
		HMgoto .text $fragment
	}
	set Url $file
	HMparse_html [get_html $file] {HMrender .text}
	set Running ready
	HMset_state .text -stop 1	;# stop rendering previous page if busy
	set message ""
}

# given a file name, return its html, or invent some html if the file can't
# be opened.

proc get_html {file} {
	global Home
	if {[catch {set fd [open $file]} msg]} {
		return "
			<title>Bad file $file</title>
			<h1>Error reading $file</h1><p>
			$msg<hr>
			<a href=$Home>Go home</a>
		"
	}
	set result [read $fd]
	close $fd
	return $result
}

# Override the library link-callback routine for the sample app.
# It only handles the simple cases.

proc HMlink_callback {win href} {
	global Url

	if {[string match #* $href]} {
		render $href
		return
	}
	if {[string match /* $href]} {
		set Url $href
	} else {
		set Url [file dirname $Url]/$href
	}
	update
	render $Url
}

# Supply an image callback function
# Read in an image if we don't already have one
# callback to library for display

proc HMset_image {win handle src} {
	global Url message
	if {[string match /* $src]} {
		set image $src
	} else {
		set image [file dirname $Url]/$src
	}
	set message "fetching image $image"
	update
	if {[string first " $image " " [image names] "] >= 0} {
		HMgot_image $handle $image
	} else {
		set type photo
		if {[file extension $image] == ".bmp"} {set type bitmap}
		catch {image create $type $image -file $image} image
		HMgot_image $handle $image
	}
}

# Handle base tags.  This breaks if more than 1 base tag is in the document

proc HMtag_base {win param text} {
	global Url
	upvar #0 HM$win var
	HMextract_param $param href Url
}

# downloading fonts can take a long time.  We'll override the default
# font-setting routine to permit better user feedback on fonts.  We'll
# keep our own list of installed fonts on the side, to guess when delays
# are likely

proc HMset_font {win tag font} {
	global message Fonts
	if {![info exists Fonts($font)]} {
		set Fonts($font) 1
		.msg configure -fg blue
		set message "downloading font $font"
		update
	}
	.msg configure -fg black
	set message ""
	catch {$win tag configure $tag -font $font} message
}

# Lets invent a new HTML tag, just for fun.
# Change the color of the text. Use html tags of the form:
# <color value=blue> ... </color>
# We can invent a new tag for the display stack.  If it starts with "T"
# it will automatically get mapped directly to a text widget tag.

proc HMtag_color {win param text} {
	upvar #0 HM$win var
	set value bad_color
	HMextract_param $param value
	$win tag configure $value -foreground $value
	HMstack $win "" "Tcolor $value"
}

proc HMtag_/color {win param text} {
	upvar #0 HM$win var
	HMstack $win / "Tcolor {}"
}

# Add a font size manipulation primitive, so we can use this sample program
# for on-line presentations.  sizes prefixed with + or - are relative.
#  <font size=[+-]3>  ..... </font>.  Note that this is not the same as
# Netscape's <font> tag.

proc HMtag_font {win param text} {
	upvar #0 HM$win var
	set size 0; set sign ""
	HMextract_param $param size
	regexp {([+-])? *([0-9]+)} $size dummy sign size
	if {$sign != ""} {
		set size [expr [lindex $var(size) end] $sign $size]
	}
	HMstack $win {} "size $size"
}

# This version is closer to what Netscape does

proc HMtag_font {win param text} {
	upvar #0 HM$win var
	set size 0; set sign ""
	HMextract_param $param size
	regexp {([+-])? *([0-9]+)} $size dummy sign size
	if {$sign != ""} {
		set size [expr [lindex $var(size) end] $sign  $size*2]
		HMstack $win {} "size $size"
	} else {
		HMstack $win {} "size [expr 10 + 2 * $size]"
	}
}

proc HMtag_/font {win param text} {
	upvar #0 HM$win var
	HMstack $win / "size {}"
}

proc CreateBrowserButtons { } {
global Url

.text2 delete 1.0 end
button .text2.go -command {HB_init .text;HB_load_url .text $Url} -bg orange -fg purple -text GO!
button .text2.back -command "HB_back .text2.back" -text Back
button .text2.forward -command "HB_forward .text2.forward" -text Forward
button .text2.stop -command "HB_Stop .text2.stop" -text Stop -bg red -fg yellow
.text2 window create 1.0 -window .text2.go
.text2 window create end -window .text2.back
.text2 window create end -window .text2.forward
.text2 window create end -window .text2.stop
}





# set initial values
set Size 4					;# font size adjustment
set Indent 1.2				;# tab spacing (cm)
set Home $rootdirectory/drug_programs/html/index.html  ;# home document
set Url $Home				;# current file
set Running busy			;# page status
set message ""				;# message line

# make the interface and render the home page
catch setup		;# the catch lets us re-source this file
HMinit_win .text
HMset_state .text -size $Size
HMset_indent .text $Indent
render $Home
