#!/usr/local/bin/itkwish3.0
wm withdraw .

# read the tcl_platform(os) variable to determine which operating system
# we're running on.  Set rootdirectory and fax program for operating
# system.

if {$tcl_platform(os) == "Linux"} {
   cd ~
   set rootdirectory [pwd]
   cd $rootdirectory/drug_programs
   set tempfaxfiledirectory "/var/local/bin"

   } else {
           set rootdirectory "c:/progra~1/tcl/bin"
           set tempfaxfiledirectory "c:/bgfax"
           }       
set maxdialattempts [lindex $argv 0]

proc Log {storename} {
   global result line
   if [eof $result] {
       puts "executing Stop procedure from Log procedure"
       Stop
       puts "returning from Log procedure after Stop procedrue"
       puts "going back to FaxFiles procedure"     
     } else {
             gets $result line
             puts $line
             split $line 
            # catch {puts [lindex $line end]}
      catch { if { [lindex $line end] == "0"} {
             SuccessDelete $storename
             return 
           
             } 
              }
      catch { if {[lindex $line end] == "3"} {
             puts "cought return code 3"
             puts "starting FailDelete procedure"
             FailDelete $storename
             return
             }
              }

      catch { if {[lindex $line end] == "2"} {
             puts "cought return code 2"

             puts "starting FailDelete procedure"
             FailDelete $storename
             return
             }
              }


#             .text insert end $line\n
#             .text see end   
     }
}

proc Stop { } {
        
           global result rootdirectory maxdialattempts
           catch {close $result}
           puts "finished Stop procedrue"
           # restart the program to loop through and find the next file
           # to fax. Pass the max no. of dial attempts to the next
           # iteration of the test3.tcl program and then shut down present
           # iteration.
           exec $rootdirectory/drug_programs/test3.tcl $maxdialattempts &
           exit
}
     
# read return codes from efax. 0 is success, 2 or 3 mean errors of some type
# if transmission was successful, delete the file in the temp fax directory so
# it won't be sent again.

proc SuccessDelete {storename} {
      global line tempfaxfiledirectory dialattempts rootdirectory  
        

         file delete $tempfaxfiledirectory/$storename
         # exec rm -f /var/local/bin/$storename
         file delete $tempfaxfiledirectory/$storename.001

            if [file isfile $tempfaxfiledirectory/$storename.002] {
            file delete $tempfaxfiledirectory/$storename.002
            }

            if [file isfile $tempfaxfiledirectory/$storename.003] {
            file delete $tempfaxfiledirectory/$storename.003
            }

         # exec rm -f /var/local/bin/$storename.001
          exec $rootdirectory/drug_programs/success.tcl $storename

          if [file isfile $tempfaxfiledirectory/$storename.dialattempts] {
                puts "deleting file $tempfaxfiledirectory/$storename.dialattempts"
                file delete $tempfaxfiledirectory/$storename.dialattempts
                  }
          
          puts "Finishing SuccessDelete procedure"
          return

}         

# if transmission of fax failed or returned an error code != 0 then do not
# delete the temp fax file so transmission can be attempted again.  Store
# the no. of times you have tried to send each file and compare to the maximum
# no. of tries allowed which is set in the TFP_drugrefill program. This was source
# of trouble since sometimes a minor error caused the program to keep sending the
# same fax over and over again.

proc FailDelete {storename} {               
                  puts "starting FailDelete procedrue..."
                  global line tempfaxfiledirectory dialattempts rootdirectory

                 
                  puts "starting to read for error log files"
                  set filelist [glob -nocomplain $tempfaxfiledirectory/*.log]
                  foreach file $filelist {puts "file is $file";file delete $file}
                  exec $rootdirectory/drug_programs/failure.tcl $storename             
                  incr dialattempts
                  puts "putting no of dialattempts = $dialattempts into file"
                  set d [open $tempfaxfiledirectory/$storename.dialattempts w]
                  puts $d $dialattempts
                  close $d
                  puts "finishing FailDelete procedure"
                  return
}


#loads the data for the drugstore name and phone no. into memory into an array

proc LoadDrugStore {} {
global rootdirectory
global tempfaxfiledirectory
global storenumber


set f [open $rootdirectory/drug_programs/drugstorelist  r]

while {[gets $f line] >0} {
     

     set line [split $line] 


     set storenumber([lindex $line 0]) [lindex $line 1]
     
     # puts "[lindex $line 0] [lindex $line 1]"
     
     }

     
close $f
}


# Main procedure of test3.tcl program.  Loops through the array $ storenumber() and stores
# the phone no. in the variable $storenumber and then if a file is waiting to be faxed and
# the number of tries has not exceeded the max no. allowed, it starts efax in a pipe and
# directs the output from the pipe to the .text widget on the left window of TFP_drugrefill.tcl
# this allows you to see what is going on with the faxes as they transmit and at the same time
# the GUI remains responsive to user input so you can enter more data even while faxing.  Works 
# great on Linux, Unfortunately, the pipe doesn't seem to work on Windows95 using bgfax.

proc FaxFiles {} {

global tempfaxfiledirectory storenumber rootdirectory result dialattempts maxdialattempts 
cd $tempfaxfiledirectory

# loop through the array storenumber( ) to get the variable that holds each store's fax no.

puts "Checking for Files to Fax for each Drugstore..."

   foreach {storename number} [array get storenumber] {

   puts "storename - $storename  number - $number"
   
   if [file isfile $storename.dialattempts] {  
    set e [open $storename.dialattempts r]
    gets $e dialattempts
    close $e
    
     }

  if {[file isfile $storename] && $dialattempts < [expr $maxdialattempts + 1]} {
   if {$rootdirectory == "/root"} {
   
 

    #catch {exec $rootdirectory/efax08a/fax send  $number $tempfaxfiledirectory/$storename} result 
     puts "A file is waiting for $storename... faxing it now..."
     catch {open "|$rootdirectory/efax08a/fax send $number $tempfaxfiledirectory/$storename |& cat"} result 

     fileevent $result readable "Log $storename"

   
    } else { 
            # catch {exec sendfax.bat $storename $number }
              catch {open "|sendfax.bat $storename $number |& type" } result
           }






tkwait variable result



} elseif {[file isfile $tempfaxfiledirectory/$storename] && $dialattempts >= [expr $maxdialattempts + 1]} {
           puts "\nA file exists for $storename but maximum no. of dialattempts of [expr $dialattempts - 1] reached..\n"
           set dialattempts 0
           }

}



cd $rootdirectory/drug_programs

}

set dialattempts 0

LoadDrugStore

FaxFiles

exit
