#
# Sensus Consulting Ltd, Copyright 1997-1998
#
# Matt Newman <matt@sensus.org>
#
#
#INDEX\
proc tk++::App {} {}

package require tk++

class tk++::App {
	inherit tk++::Applet

	constructor {args} {}

	public method menubar {option args}
	public method status {args}
	public method NewWindow {args}
	public method About {msg args}

	private method addItem {component type opts}
	protected method menuCallback {body}
}
body tk++::App::constructor {args} {
	configure -title "tk++ App"

	itk_option add hull.menu

	itk_component add menubar {
		menu $itk_interior.menubar
	}
	$itk_interior configure -menu $itk_component(menubar)

	itk_component add main {
		frame $itk_interior.main -relief ridge -borderwidth 2
	} {
		keep -background
	}
	itk_component add left {
		frame $itk_component(main).left -relief flat -borderwidth 0
	} {
		keep -background
	}
	itk_component add right {
		frame $itk_component(main).right -relief flat -borderwidth 0
	} {
		keep -background
	}
	pane $itk_component(left) $itk_component(right) -dynamic 0

	itk_component add status {
		label $itk_interior.status -anchor w -relief ridge -borderwidth 2
	} {
		keep -background -font
	}
	pack $itk_component(main) -side top -fill both -expand yes
	pack $itk_component(status) -side bottom -anchor w -fill x

	eval itk_initialize $args
}
body tk++::App::About {msg args} {
	eval [list tk_messageBox -type ok -message $msg] $args
}
body tk++::App::NewWindow {args} {
	return [eval [info class] .#auto $args]
}
body tk++::App::status {args} {
	$itk_component(status) conf -text [join $args]
	update idletasks
	return ""
}
body tk++::App::menubar {option args} {
	switch -- $option {
	add	{
		set type [lvarpop args]
		if {[llength $args]==0 || [string match -* [lindex $args 0]]} {
			return [eval $itk_component(menubar) add $type $args]
		}
		addItem menubar $type $args
	}
	};#switch
}
body tk++::App::addItem {comp type opts} {
	regsub -all {%W} $opts [winfo toplevel $itk_interior] opts

	set label [lvarpop opts]
	switch -- $type {
	options	{eval component $comp configure $opts}
	menu	-
	cascade {
		set subopts [pget $opts -menu]
		set subcomp $comp/$label
		itk_component add $subcomp {
			::menu $itk_component($comp).x$label -tearoff 0
		} {
			keep -background -font
		}
		set opts [pset $opts -menu $itk_component($subcomp)]
		eval [list $itk_component($comp) add cascade -label $label] $opts
		foreach line [split $subopts \n] {
			set line [string trim $line]
			if {$line == "" || [string match #* $line]} continue
			set type [lvarpop line]
			addItem $subcomp $type $line
		}
	}
	command -
	checkbutton -
	radiobutton {
		set cmd [pget $opts -command ""]
		if {$cmd != ""} {
			set cmd [code -namespace [virtual] $this menuCallback $cmd]
			set opts [pset $opts -command $cmd]
		}
		eval [list $itk_component($comp) add $type \
							-label $label -underline 0] $opts
	}
	separator {
		$itk_component($comp) add separator
	}
	};# switch
}
body tk++::App::menuCallback {body} {
	if [catch $body err] {
		bgerror $err
	}
}
